from datetime import datetime
from application.app import db
from models.area import AreaModel
from models import engine, BaseModel
from webcreator.log import logger
from webcreator.response import ResponseCode, response_result

class AreaResource(object):
    def __init__(self):
        super().__init__()

    def get(self, params):
        # handle business
        logger.warn("============================>")
        logger.warn(params)
        filters = [AreaModel.is_delete==False]
        logger.warn("/////////////////////////////")
        logger.warn("<<<<<<<<>>>>>>>>")
        result = db.session.query(AreaModel).filter().order_by(AreaModel.create_at).all()
        logger.warn(result)
        logger.warn("|||||||||||||||||||||||||||||")

        return result

    def getList(self, params):
        # handle business
        logger.warn(params)
        filters = []
        # result = AreaModel.query.filter(AreaModel.is_delete==False).order_by(AreaModel.create_at).all()
        result = AreaModel.query.filter(*filters).order_by(AreaModel.areaId).paginate(params.get('page', 1), params.get('pageSize', 10), error_out=False)
        logger.warn(result)
        logger.warn("$$$$$$$$$$$$$$$$$$$$$$$$$$$$$")

        return result

    def post(self, params, jwt=None):
        # handle business
        result = AreaModel.query.filter(AreaModel.areaCode == params.get('areaCode')).first()
        logger.warn(result)
        if result and result.is_delete:
            result.is_delete = False
            result.update_by = jwt.get("id", "")
            result.update_date = datetime.now()
            db.session.commit()
            return (True, None)
        elif result and result.is_delete == False:
            return (False, "area code exists")

        result = AreaModel(**params)
        db.session.add(result)
        db.session.commit()
        return (True, None)

    def put(self, id, params, jwt=None):
        # handle business
        result = AreaModel.query.get(id)
        if not result: return response_result(ResponseCode.NO_DATA)
        if params:
            for key, value in params.items():
                if value != None: setattr(result, key, value)
            result.update_by = jwt['id']
            result.update_date = datetime.now()
            db.session.commit()
        else:
            return response_result(ResponseCode.PARAM_NULL)

    def delete(self, id, jwt=None):
        # handle business
        result = AreaModel.query.get(id)
        if not result: return response_result(ResponseCode.NO_DATA_FOUND)
        else:
            result.update_by = jwt['id']
            result.update_date = datetime.now()
            result.is_delete = True
            db.session.delete(result)
            db.session.commit()

areaManager = AreaResource()